<div id="body" class="container-fluid">
  <div class="row mx-n5">
    <div class="col">
      <h6 class="mb-1">CPT</h6>
      <form [formGroup]="form" novalidate>
        <div class="form-row">
          <div class="form-group form-group-sm row col-24 text-right">
            <label>
              If you have any questions regarding this form content, how to fill out the on-boarding request,
              etc. please send an email to the&nbsp;<a href="mailto:MNS-CPT@t-mobile.com">CPT Help PDL</a>.
            </label>
          </div>
        </div>

        <div class="form-row">
          <div class="form-group form-group-sm row col-24 text-justify text-danger">
            <label>
              IMPORTANT: Please confirm all data is accurate before submitting the CPT request.
              Invalid or dummy info should not be submitted. If the form has to be corrected after submittal,
              the CPT request will have to be canceled, and a new CPT request submitted with the correct info.
            </label>
          </div>
        </div>

        <div class="form-row text-center mt-1">
          <div class="form-group form-group-sm row col-24 text-danger">
            <h6 class="col-24 text-center" *ngIf="!isLocked && editMode && allowEdit && id > 0">This CPT Request will be locked from other users until you click the Save or Cancel button.</h6>
            <h6 class="col-24 text-center" *ngIf="isLocked">This CPT is currently locked by {{ lockedByUser }}</h6>
            <h6 class="col-24 text-center" *ngIf="!allowEdit">This CPT request has been {{ cptData?.cptStatus }}. Updating this record is not allowed.</h6>
            <h6 class="col-24 text-center" *ngIf="viewOnly">Sorry, you do not have access to update this CPT Request. Kindly contact your supervisor or application administrator for details.</h6>
          </div>
          <div class="form-group form-group-sm col-12 col-md-6 col-lg-4 offset-md-6 offset-lg-8"
               *ngIf="!isLocked && allowEdit && !viewOnly">
            <div *ngIf="editMode; then saveTemplate; else editTemplate;"></div>
            <ng-template #editTemplate>
              <button type="button" class="btn btn-sm btn-primary btn-block" (click)="edit()">
                Edit
              </button>
            </ng-template>
            <ng-template #saveTemplate>
              <button type="button" class="btn btn-sm btn-primary btn-block" (click)="save()">
                Save
              </button>
            </ng-template>
          </div>
          <div class="form-group form-group-sm col-12 col-md-6 col-lg-4"
               [ngClass]="{ 'offset-lg-10' : (isLocked || !allowEdit || viewOnly) }">
            <button type="button" class="btn btn-sm btn-secondary btn-block" (click)="cancel()">
              Cancel
            </button>
          </div>

        </div>

        <div class="form-row" *ngIf="id > 0">
          <label class="text-danger" *ngIf="!allowCreate">
            Sorry, you do not have access to update <span class="font-weight-bold">THIS SECTION</span>. Kindly contact your supervisor or application administrator for details.
          </label>
          <div class="form-group form-group-sm row col-24 col-lg-12">
            <label class="col-form-label col-24 col-lg-8">CPT #: </label>
            <div class="col-24 col-lg-16 pl-0 pl-lg-1">
              <label class="col-form-label">{{ cptData?.cptCustNbr }}</label>
            </div>
          </div>
        </div>

        <!-- Submitter -->
        <app-requestor-template [group]="form.controls.requestor" [option]="option.requestor"
                                [isSubmitted]="isSubmitted"></app-requestor-template>

        <!-- Sprint Sales Team -->
        <mat-accordion>
          <mat-expansion-panel [expanded]="true" class="mb-1">
            <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
              <mat-panel-title><h6>T-Mobile Sales Team</h6></mat-panel-title>
            </mat-expansion-panel-header>
            <fieldset [disabled]="!editMode">
              <div formGroupName="sprintSalesTeam">
                <div class="form-row">
                  <!--<div class="form-group form-group-sm row col-24 col-lg-12">
          <label class="col-form-label col-24 col-lg-8 text-danger">SE Email: </label>
          <div class="col-24 col-lg-16 pl-0 pl-lg-1">
            <div class="input-group">
              <input type="text" class="form-control form-control-sm" formControlName="seEmail" />
              <app-user-finder *ngIf="option.sprintSalesTeam.userFinderForSeEmail?.isEnabled"
                               id="se-email" [group]="form.controls.sprintSalesTeam"
                               [option]="option.sprintSalesTeam.userFinderForSeEmail"></app-user-finder>
            </div>
            <div *ngIf="seEmail.invalid && (seEmail.dirty || seEmail.touched || isSubmitted)">
              <span *ngIf="seEmail.errors.invalidEmail" class="form-text text-danger">
                SE Email is invalid
              </span>
            </div>
            <div *ngIf="seEmail.invalid && (seEmail.dirty || seEmail.touched || isSubmitted)">
              <span *ngIf="seEmail.errors.required" class="form-text text-danger">
                SE Email is required
              </span>
            </div>
          </div>
        </div>-->
                  <div class="form-group form-group-sm row col-24 col-lg-12">
                    <label class="col-form-label col-24 col-lg-8 text-danger">Select Customer: </label>
                    <div class="col-24 col-lg-16 pl-0 pl-lg-1" data-toggle="tooltip"
                         title="If design document is not uploaded to BPM for access, H1 or customer name will not be in this drop down. Manually enter the H1 in the text box and all other information manually.">
                      <dx-select-box [dataSource]="customerListDS" formControlName="customer"
                                     displayExpr="custH1Display" valueExpr="h1"
                                     [searchEnabled]="true" [searchExpr]="['custH1Display']"
                                     searchMode="contains" (onValueChanged)="onCustomerH1Changed($event)">
                      </dx-select-box>
                    </div>
                  </div>
                  <div class="form-group form-group-sm row col-24 col-lg-12">
                    <label class="col-form-label col-24 col-lg-8 text-danger"># of Devices: </label>
                    <div class="col-24 col-lg-16 pl-0 pl-lg-1">
                      <input type="number" class="form-control form-control-sm" formControlName="noOfDevices" />
                      <div *ngIf="noOfDevices.invalid && (noOfDevices.dirty || noOfDevices.touched || isSubmitted)">
                        <span *ngIf="noOfDevices.errors.required" class="form-text text-danger">
                          No of Devices is required
                        </span>
                      </div>
                    </div>
                  </div>
                </div>
                <div class="form-row">
                  <!--<div class="form-group form-group-sm row col-24 col-lg-12">
          <label class="col-form-label col-24 col-lg-8 text-danger">Account Manager Email: </label>
          <div class="col-24 col-lg-16 pl-0 pl-lg-1">
            <div class="input-group">
              <input type="text" class="form-control form-control-sm" formControlName="amEmail" />
              <app-user-finder *ngIf="option.sprintSalesTeam.userFinderForAmEmail?.isEnabled"
                               id="am-email" [group]="form.controls.sprintSalesTeam"
                               [option]="option.sprintSalesTeam.userFinderForAmEmail"></app-user-finder>
            </div>
            <div *ngIf="amEmail.invalid && (amEmail.dirty || amEmail.touched || isSubmitted)">
              <span *ngIf="amEmail.errors.invalidEmail" class="form-text text-danger">
                Account Manager Email is invalid
              </span>
            </div>
            <div *ngIf="amEmail.invalid && (amEmail.dirty || amEmail.touched || isSubmitted)">
              <span *ngIf="amEmail.errors.required" class="form-text text-danger">
                Account Manager Email is required
              </span>
            </div>
          </div>
        </div>-->
                  <div class="form-group form-group-sm row col-24 col-lg-12">
                    <label class="col-form-label col-24 col-lg-8">H1 ID: </label>
                    <div class="col-24 col-lg-16 pl-0 pl-lg-1">
                      <input type="text" class="form-control form-control-sm" formControlName="h1" />
                      <div *ngIf="h1.invalid && (h1.dirty || h1.touched)">
                        <span *ngIf="h1.errors.required" class="form-text text-danger">
                          H1 is required
                        </span>
                        <span *ngIf="h1.errors.invalidH1" class="form-text text-danger">
                          H1 field is not in correct format. H1 should contain 9 digits only.
                        </span>
                      </div>
                    </div>
                  </div>
                  <div class="form-group form-group-sm row col-24 col-lg-12">
                    <label class="col-form-label col-24 col-lg-8">Contact Email Addresses:</label>
                    <div class="col-24 col-lg-16 pl-0 pl-lg-1">
                      <div class="input-group">
                        <input type="text" class="form-control form-control-sm" formControlName="contactEmails" />
                        <app-user-finder *ngIf="option.sprintSalesTeam.userFinderForContactEmailAddresses?.isEnabled" id="contact-email" [group]="form.controls.sprintSalesTeam" [option]="option.sprintSalesTeam.userFinderForContactEmailAddresses"></app-user-finder>
                      </div>
                    </div>
                  </div>
                  <!--<div class="form-group form-group-sm row col-24 col-lg-12">
          <label class="col-form-label col-24 col-lg-8">Contact Email Addresses:</label>
          <div class="col-24 col-lg-16 pl-0 pl-lg-1">
            <dx-tag-box [items]="additionalEmails"
                        [acceptCustomValue]="true"
                        formControlName="contactEmails"
                        (onCustomItemCreating)="onCustomContactCreating($event)">
            </dx-tag-box>
          </div>
        </div>-->
                </div>
                <!--<div class="form-row">
        <div class="form-group form-group-sm row col-24 col-lg-12">
          <label class="col-form-label col-24 col-lg-8 text-danger">IPM Email: </label>
          <div class="col-24 col-lg-16 pl-0 pl-lg-1">
            <div class="input-group">
              <input type="text" class="form-control form-control-sm" formControlName="ipmEmail" />
              <app-user-finder *ngIf="option.sprintSalesTeam.userFinderForIpmEmail?.isEnabled"
                               id="ipm-email" [group]="form.controls.sprintSalesTeam"
                               [option]="option.sprintSalesTeam.userFinderForIpmEmail"></app-user-finder>
            </div>
            <div *ngIf="ipmEmail.invalid && (ipmEmail.dirty || ipmEmail.touched || isSubmitted)">
              <span *ngIf="ipmEmail.errors.invalidEmail" class="form-text text-danger">
                IPM Email is invalid
              </span>
            </div>
            <div *ngIf="ipmEmail.invalid && (ipmEmail.dirty || ipmEmail.touched || isSubmitted)">
              <span *ngIf="ipmEmail.errors.required" class="form-text text-danger">
                IPM Email is required
              </span>
            </div>
          </div>
        </div>
        <div class="form-group form-group-sm row col-24 col-lg-12">
          <label class="col-form-label col-24 col-lg-8 text-danger"># of Devices: </label>
          <div class="col-24 col-lg-16 pl-0 pl-lg-1">
            <input type="number" class="form-control form-control-sm" formControlName="noOfDevices" />
            <div *ngIf="noOfDevices.invalid && (noOfDevices.dirty || noOfDevices.touched || isSubmitted)">
              <span *ngIf="noOfDevices.errors.required" class="form-text text-danger">
                No of Devices is required
              </span>
            </div>
          </div>
        </div>
      </div>-->
              </div>
            </fieldset>
          </mat-expansion-panel>
        </mat-accordion>

        <!-- Contact List -->
        <app-contact-list #cntctList id="cntctList" [disabled]="!editMode" [objType]="objType" [objId]="id" [parent]="this"
                          [contactList]="contactList" (result)="onContactDetailSaved($event)"></app-contact-list>

        <!-- Additional Information -->
        <mat-accordion>
          <mat-expansion-panel [expanded]="true" class="mb-1">
            <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
              <mat-panel-title><h6>Additional Information</h6></mat-panel-title>
            </mat-expansion-panel-header>
            <div class="form-row">
              <div class="form-group form-group-sm row col-24">
                <label class="col-form-label col-24 col-lg-4 text-danger">Customer Type: </label>
                <div class="col-24 col-lg-20 pl-0 pl-lg-1">
                  <dx-tag-box [dataSource]="customerTypeList"
                              displayExpr="cptCustType"
                              valueExpr="cptCustTypeId"
                              formControlName="customerTypes"
                              [showSelectionControls]="true"
                              (onSelectionChanged)="onCustomerTypeChanged($event)">
                  </dx-tag-box>
                  <div *ngIf="customerTypes.invalid && (customerTypes.dirty || customerTypes.touched || isSubmitted)">
                    <span *ngIf="customerTypes.errors.required" class="form-text text-danger">
                      Customer Type is required
                    </span>
                    <span *ngIf="customerTypes.errors.invalidCPTCustType" class="form-text text-danger">
                      Multiple selections are only allowable if both Managed Data and Managed Security are selected. Any other combination is not allowed.
                    </span>
                  </div>
                  <div>
                    <label>If you would like to on-board an Professional Services or Managed Security opportunity, please ensure the pre-sales engagement process has been completed.</label>
                  </div>
                </div>
              </div>
            </div>
          </mat-expansion-panel>
        </mat-accordion>

        <!-- Customer -->
        <mat-accordion>
          <mat-expansion-panel [expanded]="true" class="mb-1">
            <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
              <mat-panel-title><h6>Customer</h6></mat-panel-title>
            </mat-expansion-panel-header>
            <div formGroupName="customer">
              <div class="form-row">
                <div class="form-group form-group-sm row col-24">
                  <label class="col-form-label col-24 col-lg-4 text-danger">Company Name: </label>
                  <div class="col-24 col-lg-20 pl-0 pl-lg-1">
                    <input type="text" class="form-control form-control-sm" formControlName="company" />
                    <div *ngIf="company.invalid && (company.dirty || company.touched || isSubmitted)">
                      <span *ngIf="company.errors.required" class="form-text text-danger">
                        Company is required
                      </span>
                    </div>
                  </div>
                </div>
              </div>
              <div class="form-row">
                <div class="form-group form-group-sm row col-24">
                  <label class="col-form-label col-4 text-danger">Address: </label>
                  <div class="col-5 pl-0 pl-lg-1">
                    <input type="text" class="form-control form-control-sm" formControlName="address" />
                    <div *ngIf="address.invalid && (address.dirty || address.touched || isSubmitted)">
                      <span *ngIf="address.errors.required" class="form-text text-danger">
                        Address is required
                      </span>
                    </div>
                  </div>
                  <label class="col-form-label col-3">Bldg/Floor/Room: </label>
                  <div class="col-5 pl-0 pl-lg-1">
                    <input type="text" class="form-control form-control-sm" formControlName="bldgRmFlr" />
                  </div>
                  <label class="col-form-label col-2 text-danger">City: </label>
                  <div class="col-5 pl-0 pl-lg-1">
                    <input type="text" class="form-control form-control-sm" formControlName="city" />
                    <div *ngIf="city.invalid && (city.dirty || city.touched || isSubmitted)">
                      <span *ngIf="city.errors.required" class="form-text text-danger">
                        City is required
                      </span>
                    </div>
                  </div>
                </div>
              </div>
              <div class="form-row">
                <div class="form-group form-group-sm row col-24">
                  <label class="col-form-label col-4 text-danger">State/Province: </label>
                  <div class="col-5 pl-0 pl-lg-1">
                    <input type="text" class="form-control form-control-sm" formControlName="state" />
                    <div *ngIf="state.invalid && (state.dirty || state.touched || isSubmitted)">
                      <span *ngIf="state.errors.required" class="form-text text-danger">
                        State/Province is required
                      </span>
                    </div>
                  </div>
                  <label class="col-form-label col-3 text-danger">Country: </label>
                  <div class="col-5 pl-0 pl-lg-1">
                    <input type="text" class="form-control form-control-sm" formControlName="country" />
                    <div *ngIf="country.invalid && (country.dirty || country.touched || isSubmitted)">
                      <span *ngIf="country.errors.required" class="form-text text-danger">
                        Country is required
                      </span>
                    </div>
                  </div>
                  <label class="col-form-label col-2 text-danger">ZIP Code: </label>
                  <div class="col-5 pl-0 pl-lg-1">
                    <input type="text" class="form-control form-control-sm" formControlName="zip" />
                    <div *ngIf="zip.invalid && (zip.dirty || zip.touched || isSubmitted)">
                      <span *ngIf="zip.errors.required" class="form-text text-danger">
                        ZIP Code is required
                      </span>
                    </div>
                  </div>
                </div>
              </div>
              <div class="form-row">
                <div class="form-group form-group-sm row col-12">
                  <label class="col-form-label col-16 text-danger">Does this customer fall under a T-Mobile Wholesale Reseller?</label>
                  <div class="col-8 pl-0 pl-lg-1">
                    <dx-radio-group [items]="yesOrNoList" layout="horizontal"
                                    displayExpr="description" valueExpr="value"
                                    formControlName="isSprintWholesaleReseller">
                    </dx-radio-group>
                    <div *ngIf="isSprintWholesaleReseller.invalid && (isSprintWholesaleReseller.dirty || isSprintWholesaleReseller.touched || isSubmitted)">
                      <span *ngIf="isSprintWholesaleReseller.errors.required" class="form-text text-danger">
                        T-Mobile Wholesale Reseller is required
                      </span>
                    </div>
                  </div>
                </div>
                <div class="form-group form-group-sm row col-12" *ngIf="isSprintWholesaleReseller.value == 1">
                  <label class="col-form-label col-10 text-danger">T-Mobile Wholesale Reseller Name: </label>
                  <div class="col-14 pl-0 pl-lg-1">
                    <input type="text" class="form-control form-control-sm"
                           value="{{ isSprintWholesaleReseller.value == 1 ? (id > 0 ? wholesaleResellerName.value : null) : null }}"
                           formControlName="wholesaleResellerName" />
                    <div *ngIf="wholesaleResellerName.invalid && (wholesaleResellerName.dirty || wholesaleResellerName.touched || isSubmitted)">
                      <span *ngIf="wholesaleResellerName.errors.required" class="form-text text-danger">
                        T-Mobile Wholesale Reseller Name is required
                      </span>
                    </div>
                  </div>
                </div>
              </div>
              <div class="form-row">
                <div class="form-group form-group-sm row col-12">
                  <label class="col-form-label col-16 text-danger">Is this a Government Customer?</label>
                  <div class="col-8 pl-0 pl-lg-1">
                    <dx-radio-group [items]="yesOrNoList" layout="horizontal"
                                    displayExpr="description" valueExpr="value"
                                    formControlName="isGovernmentCustomer">
                    </dx-radio-group>
                    <div *ngIf="isGovernmentCustomer.invalid && (isGovernmentCustomer.dirty || isGovernmentCustomer.touched || isSubmitted)">
                      <span *ngIf="isGovernmentCustomer.errors.required" class="form-text text-danger">
                        Government Customer is required
                      </span>
                    </div>
                  </div>
                </div>
                <div class="form-group form-group-sm row col-12" *ngIf="isGovernmentCustomer.value == 1">
                  <label class="col-form-label col-10 text-danger">Is a Security Clearance required?</label>
                  <div class="col-14 pl-0 pl-lg-1">
                    <dx-radio-group [items]="yesOrNoList" layout="horizontal"
                                    displayExpr="description" valueExpr="value"
                                    formControlName="isSecurityClearance">
                    </dx-radio-group>
                    <div *ngIf="isSecurityClearance.invalid && (isSecurityClearance.dirty || isSecurityClearance.touched || isSubmitted)">
                      <span *ngIf="isSecurityClearance.errors.required" class="form-text text-danger">
                        Security Clearance is required
                      </span>
                    </div>
                  </div>
                </div>
              </div>
            </div>
          </mat-expansion-panel>
        </mat-accordion>

        <!-- Required Information -->
        <mat-accordion *ngIf="customerTypes.value?.length > 1
        || (customerTypes.value?.length == 1 && (!customerTypes.value?.includes(3)
        && !customerTypes.value?.includes(4) && !customerTypes.value?.includes(5)))">
          <mat-expansion-panel [expanded]="true" class="mb-1">
            <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
              <mat-panel-title><h6>Required Information</h6></mat-panel-title>
            </mat-expansion-panel-header>
            <div formGroupName="requiredInfo">
              <div class="form-row">
                <div class="form-group form-group-sm row col-12">
                  <label class="col-form-label col-16 text-danger">Is this customer requesting TACACS access to devices?</label>
                  <div class="col-8 pl-0 pl-lg-1">
                    <dx-radio-group [items]="yesOrNoList" layout="horizontal"
                                    displayExpr="description" valueExpr="value"
                                    formControlName="isTacacs">
                    </dx-radio-group>
                    <div *ngIf="isTacacs.invalid && (isTacacs.dirty || isTacacs.touched || isSubmitted)">
                      <span *ngIf="isTacacs.errors.required" class="form-text text-danger">
                        TACACS access to devices is required
                      </span>
                    </div>
                  </div>
                </div>
              </div>
              <div class="form-row">
                <div class="form-group form-group-sm row col-12">
                  <label class="col-form-label col-16 text-danger">Is this customer requesting ENCRYPTED MODEMS?</label>
                  <div class="col-8 pl-0 pl-lg-1">
                    <dx-radio-group [items]="yesOrNoList" layout="horizontal"
                                    displayExpr="description" valueExpr="value"
                                    formControlName="isEncryptedModems">
                    </dx-radio-group>
                    <div *ngIf="isEncryptedModems.invalid && (isEncryptedModems.dirty || isEncryptedModems.touched || isSubmitted)">
                      <span *ngIf="isEncryptedModems.errors.required" class="form-text text-danger">
                        ENCRYPTED MODEMS is required
                      </span>
                    </div>
                  </div>
                </div>
              </div>
              <div class="form-row">
                <div class="form-group form-group-sm row col-12">
                  <label class="col-form-label col-16 text-danger">Is this customer purchasing a HOSTED Managed Service?</label>
                  <div class="col-8 pl-0 pl-lg-1">
                    <dx-radio-group [items]="yesOrNoList" layout="horizontal"
                                    displayExpr="description" valueExpr="value"
                                    formControlName="isHostedManagedService">
                    </dx-radio-group>
                    <div *ngIf="isHostedManagedService.invalid && (isHostedManagedService.dirty || isHostedManagedService.touched || isSubmitted)">
                      <span *ngIf="isHostedManagedService.errors.required" class="form-text text-danger">
                        HOSTED Managed Service is required
                      </span>
                    </div>
                  </div>
                </div>
                <div class="form-group form-group-sm row col-12" *ngIf="isHostedManagedService.value == 1">
                  <label class="col-form-label col-10 text-danger">HOSTED Managed Service Type: </label>
                  <div class="col-14 pl-0 pl-lg-1">
                    <dx-tag-box [dataSource]="hostManagedList"
                                displayExpr="cptHstMngdSrvc"
                                valueExpr="cptHstMngdSrvcId"
                                formControlName="hstMngdSrvc"
                                [showSelectionControls]="true">
                    </dx-tag-box>
                  </div>
                </div>
              </div>
              <div class="form-row">
                <div class="form-group form-group-sm row col-12">
                  <label class="col-form-label col-16 text-danger">Is this customer purchasing SDWAN and/or Meraki Managed Services?</label>
                  <div class="col-8 pl-0 pl-lg-1">
                    <dx-radio-group [items]="yesOrNoList" layout="horizontal"
                                    displayExpr="description" valueExpr="value"
                                    formControlName="isSdwanOrMeraki"
                                    (onValueChanged)="onSdwanChanged($event)">
                    </dx-radio-group>
                    <div *ngIf="isSdwanOrMeraki.invalid && (isSdwanOrMeraki.dirty || isSdwanOrMeraki.touched || isSubmitted)">
                      <span *ngIf="isSdwanOrMeraki.errors.required" class="form-text text-danger">
                        SDWAN and/or Meraki Managed Services is required
                      </span>
                    </div>
                  </div>
                </div>
              </div>
            </div>
          </mat-expansion-panel>
        </mat-accordion>

        <!-- Managed Data Service -->
        <mat-accordion *ngIf="customerTypes.value?.includes(1)">
          <mat-expansion-panel [expanded]="true" class="mb-1">
            <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
              <mat-panel-title><h6>Managed Data Service</h6></mat-panel-title>
            </mat-expansion-panel-header>
            <div class="form-row">
              <div class="form-group form-group-sm row col-24">
                <label class="col-form-label col-24 col-lg-8 text-danger">Please select Planned Service Tier(s) for this Customer: </label>
                <div class="col-24 col-lg-16 pl-0 pl-lg-1">
                  <dx-tag-box [dataSource]="plannedSrvcTiersList"
                              displayExpr="cptPlnSrvcTier"
                              valueExpr="cptPlnSrvcTierId"
                              formControlName="plannedSrvcTiers"
                              [showSelectionControls]="true">
                  </dx-tag-box>
                  <div *ngIf="plannedSrvcTiers.invalid && (plannedSrvcTiers.dirty || plannedSrvcTiers.touched || isSubmitted)">
                    <span *ngIf="plannedSrvcTiers.errors.required" class="form-text text-danger">
                      Planned Service Tier is required
                    </span>
                  </div>
                </div>
              </div>
            </div>
          </mat-expansion-panel>
        </mat-accordion>

        <!-- MDS MSS Solutions -->
        <mat-accordion *ngIf="customerTypes.value?.includes(1) && plannedSrvcTiers.value?.includes(1)">
          <mat-expansion-panel [expanded]="true" class="mb-1">
            <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
              <mat-panel-title><h6>MSS Solutions</h6></mat-panel-title>
            </mat-expansion-panel-header>
            <div formGroupName="mdsMss">
              <div class="form-row">
                <div class="form-group form-group-sm row col-24">
                  <label class="col-form-label col-24 col-lg-8 text-danger">Please select Primary WAN Transport and # of Site(s): </label>
                  <div class="col-24 col-lg-16 pl-0 pl-lg-1">
                    <dx-data-grid #gridMssPrimTrnsprt id="gridMssPrimTrnsprt"
                                  [dataSource]="mssPrimTransportList" [disabled]="!editMode"
                                  [showBorders]="true" [wordWrapEnabled]="true"
                                  [rowAlternationEnabled]="true" [columnAutoWidth]="true">
                      <dxo-sorting mode="multiple"></dxo-sorting>
                      <dxo-editing mode="cell" [allowAdding]="true"
                                   [allowUpdating]="true" [allowDeleting]="true"></dxo-editing>
                      <dxi-column dataField="cptPrimScndyTprtId" caption="Primary Transport Type" dataType="string">
                        <dxo-lookup [dataSource]="primTransportList" valueExpr="value"
                                    displayExpr="description" [minWidth]="150">
                        </dxo-lookup>
                        <dxi-validation-rule type="required"></dxi-validation-rule>
                      </dxi-column>
                      <dxi-column dataField="qty" caption="Number of Sites" dataType="number" alignment="left">
                        <dxi-validation-rule type="required"></dxi-validation-rule>
                      </dxi-column>
                    </dx-data-grid>
                  </div>
                </div>
              </div>
              <div class="form-row">
                <div class="form-group form-group-sm row col-24">
                  <label class="col-form-label col-24 col-lg-8">Please select Secondary (Backup) Transport Type(s): </label>
                  <div class="col-24 col-lg-16 pl-0 pl-lg-1">
                    <dx-tag-box [dataSource]="primTransportList"
                                displayExpr="description"
                                valueExpr="value"
                                formControlName="secTrnsprtTypes"
                                [showSelectionControls]="true">
                    </dx-tag-box>
                  </div>
                </div>
              </div>
              <div class="form-row">
                <div class="form-group form-group-sm row col-24">
                  <label class="col-form-label col-24 col-lg-10 text-danger">Does this customer have Hosted UC provided by a Third Party Vendor?</label>
                  <div class="col-24 col-lg-6 pl-0 pl-lg-1">
                    <dx-radio-group [items]="yesOrNoList" layout="horizontal"
                                    displayExpr="description" valueExpr="value"
                                    formControlName="isHostedUC">
                    </dx-radio-group>
                  </div>
                </div>
              </div>
              <div class="form-row">
                <div class="form-group form-group-sm row col-24">
                  <label class="col-form-label col-24 col-lg-20 text-danger">Will MNS be required to manage any Cisco Unified Border Elements (CUBEs) or TDM Gateways supporting T-Mobile SIP (SIPT) or T-Mobile Mobile Integration?</label>
                  <div class="col-24 col-lg-4 pl-0 pl-lg-1">
                    <dx-radio-group [items]="yesOrNoList" layout="horizontal"
                                    displayExpr="description" valueExpr="value"
                                    formControlName="isCubes">
                    </dx-radio-group>
                  </div>
                </div>
              </div>
              <div class="form-row">
                <div class="form-group form-group-sm row col-24">
                  <label class="col-form-label col-24 col-lg-6">Network Design Document in DocShare: </label>
                  <div class="col-24 col-lg-18 pl-0 pl-lg-1">
                    <div class="input-group">
                      <input type="text" class="form-control form-control-sm" formControlName="networkDesignDocUrl" />
                      <button type="button" class="btn btn-sm btn-primary" [disabled]="!editMode"
                              (click)="openDesignDocUrl(mdsMssNddUrl.value)">
                        GO
                      </button>
                    </div>
                  </div>
                </div>
              </div>
              <div class="form-row">
                <div class="form-group form-group-sm row col-24">
                  <label class="col-form-label col-24 col-lg-6">Additional Comments: </label>
                  <div class="col-24 col-lg-18 pl-0 pl-lg-1">
                    <textarea class="form-control form-control-sm" formControlName="comments"
                              rows="5" maxlength="500"></textarea>
                  </div>
                </div>
              </div>
            </div>
          </mat-expansion-panel>
        </mat-accordion>

        <!-- MDS Complete/Collaborative -->
        <mat-accordion *ngIf="customerTypes.value?.includes(1) && plannedSrvcTiers.value?.includes(2)">
          <mat-expansion-panel [expanded]="true" class="mb-1">
            <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
              <mat-panel-title><h6>MDS Complete/Collaborative</h6></mat-panel-title>
            </mat-expansion-panel-header>
            <div formGroupName="mdsComplete">
              <div class="form-row">
                <div class="form-group form-group-sm row col-24">
                  <label class="col-form-label col-24 col-lg-8 text-danger">Please select Primary WAN Transport and # of Site(s): </label>
                  <div class="col-24 col-lg-16 pl-0 pl-lg-1">
                    <dx-data-grid #gridMdsCmpltPrimTrnsprt id="gridMdsCmpltPrimTrnsprt"
                                  [dataSource]="mdsCmpltPrimTransportList" [disabled]="!editMode"
                                  [showBorders]="true" [wordWrapEnabled]="true"
                                  [rowAlternationEnabled]="true" [columnAutoWidth]="true">
                      <dxo-sorting mode="multiple"></dxo-sorting>
                      <dxo-editing mode="cell" [allowAdding]="true"
                                   [allowUpdating]="true" [allowDeleting]="true"></dxo-editing>
                      <dxi-column dataField="cptPrimScndyTprtId" caption="Primary Transport Type" dataType="string">
                        <dxo-lookup [dataSource]="primTransportList" valueExpr="value"
                                    displayExpr="description" [minWidth]="150">
                        </dxo-lookup>
                        <dxi-validation-rule type="required"></dxi-validation-rule>
                      </dxi-column>
                      <dxi-column dataField="qty" caption="Number of Sites" dataType="number" alignment="left">
                        <dxi-validation-rule type="required"></dxi-validation-rule>
                      </dxi-column>
                    </dx-data-grid>
                  </div>
                </div>
              </div>
              <div class="form-row">
                <div class="form-group form-group-sm row col-24">
                  <label class="col-form-label col-24 col-lg-8">Please select Secondary (Backup) Transport Type(s): </label>
                  <div class="col-24 col-lg-16 pl-0 pl-lg-1">
                    <dx-tag-box [dataSource]="primTransportList"
                                displayExpr="description"
                                valueExpr="value"
                                formControlName="secTrnsprtTypes"
                                [showSelectionControls]="true">
                    </dx-tag-box>
                  </div>
                </div>
              </div>
              <div class="form-row">
                <div class="form-group form-group-sm row col-24">
                  <label class="col-form-label col-24 col-lg-10 text-danger">Does this customer have Hosted UC provided by a Third Party Vendor?</label>
                  <div class="col-24 col-lg-6 pl-0 pl-lg-1">
                    <dx-radio-group [items]="yesOrNoList" layout="horizontal"
                                    displayExpr="description" valueExpr="value"
                                    formControlName="isHostedUC">
                    </dx-radio-group>
                  </div>
                </div>
              </div>
              <div class="form-row">
                <div class="form-group form-group-sm row col-24">
                  <label class="col-form-label col-24 col-lg-20 text-danger">Will MNS be required to manage any Cisco Unified Border Elements (CUBEs) or TDM Gateways supporting T-Mobile SIP (SIPT) or T-Mobile Mobile Integration?</label>
                  <div class="col-24 col-lg-4 pl-0 pl-lg-1">
                    <dx-radio-group [items]="yesOrNoList" layout="horizontal"
                                    displayExpr="description" valueExpr="value"
                                    formControlName="isCubes">
                    </dx-radio-group>
                  </div>
                </div>
              </div>
              <div class="form-row">
                <div class="form-group form-group-sm row col-24">
                  <label class="col-form-label col-24 col-lg-8 text-danger">Is this an SDWAN and/or Meraki ONLY Customer?</label>
                  <div class="col-24 col-lg-6 pl-0 pl-lg-1">
                    <dx-radio-group [items]="yesOrNoList" layout="horizontal"
                                    displayExpr="description" valueExpr="value"
                                    formControlName="isSdwanMerakiOnlyCustomer"
                                    [disabled]="isSdwanOrMeraki.value != 1">
                    </dx-radio-group>
                  </div>
                </div>
              </div>
              <div class="form-row">
                <div class="form-group form-group-sm row col-24">
                  <label class="col-form-label col-24 col-lg-6">Network Design Document in DocShare: </label>
                  <div class="col-24 col-lg-18 pl-0 pl-lg-1">
                    <div class="input-group">
                      <input type="text" class="form-control form-control-sm" formControlName="networkDesignDocUrl" />
                      <button type="button" class="btn btn-sm btn-primary" [disabled]="!editMode"
                              (click)="openDesignDocUrl(mdsCmpltNddUrl.value)">
                        GO
                      </button>
                    </div>
                  </div>
                </div>
              </div>
              <div class="form-row">
                <div class="form-group form-group-sm row col-24">
                  <label class="col-form-label col-24 col-lg-6">Additional Comments: </label>
                  <div class="col-24 col-lg-18 pl-0 pl-lg-1">
                    <textarea class="form-control form-control-sm" formControlName="comments" rows="5" maxlength="500"></textarea>
                  </div>
                </div>
              </div>
            </div>
          </mat-expansion-panel>
        </mat-accordion>

        <!-- MDS Support -->
        <mat-accordion *ngIf="customerTypes.value?.includes(1) && plannedSrvcTiers.value?.includes(3)">
          <mat-expansion-panel [expanded]="true" class="mb-1">
            <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
              <mat-panel-title><h6>MDS Support</h6></mat-panel-title>
            </mat-expansion-panel-header>
            <div formGroupName="mdsSupport">
              <div class="form-row">
                <div class="form-group form-group-sm row col-24">
                  <label class="col-form-label col-24 col-lg-8 text-danger">Please select Primary WAN Transport and # of Site(s): </label>
                  <div class="col-24 col-lg-16 pl-0 pl-lg-1">
                    <dx-data-grid #gridMdsSupportPrimTrnsprt id="gridMdsSupportPrimTrnsprt"
                                  [dataSource]="mdsSupportPrimTransportList" [disabled]="!editMode"
                                  [showBorders]="true" [wordWrapEnabled]="true"
                                  [rowAlternationEnabled]="true" [columnAutoWidth]="true">
                      <dxo-sorting mode="multiple"></dxo-sorting>
                      <dxo-editing mode="cell" [allowAdding]="true"
                                   [allowUpdating]="true" [allowDeleting]="true"></dxo-editing>
                      <dxi-column dataField="cptPrimScndyTprtId" caption="Primary Transport Type" dataType="string">
                        <dxo-lookup [dataSource]="primTransportList" valueExpr="value"
                                    displayExpr="description" [minWidth]="150">
                        </dxo-lookup>
                        <dxi-validation-rule type="required"></dxi-validation-rule>
                      </dxi-column>
                      <dxi-column dataField="qty" caption="Number of Sites" dataType="number" alignment="left">
                        <dxi-validation-rule type="required"></dxi-validation-rule>
                      </dxi-column>
                    </dx-data-grid>
                  </div>
                </div>
              </div>
              <div class="form-row">
                <div class="form-group form-group-sm row col-24">
                  <label class="col-form-label col-24 col-lg-8">Please select Secondary (Backup) Transport Type(s): </label>
                  <div class="col-24 col-lg-16 pl-0 pl-lg-1">
                    <dx-tag-box [dataSource]="primTransportList"
                                displayExpr="description"
                                valueExpr="value"
                                formControlName="secTrnsprtTypes"
                                [showSelectionControls]="true">
                    </dx-tag-box>
                  </div>
                </div>
              </div>
              <div class="form-row">
                <div class="form-group form-group-sm row col-24">
                  <label class="col-form-label col-24 col-lg-8 text-danger">Please select ALL applicable MDS Support Tier(s): </label>
                  <div class="col-24 col-lg-16 pl-0 pl-lg-1">
                    <dx-tag-box [dataSource]="mdsSupportTiersList"
                                displayExpr="cptMdsSuprtTier"
                                valueExpr="cptMdsSuprtTierId"
                                formControlName="mdsSupportTiers"
                                [showSelectionControls]="true">
                    </dx-tag-box>
                    <div *ngIf="mdsSupportTiers.invalid && (mdsSupportTiers.dirty || mdsSupportTiers.touched || isSubmitted)">
                      <span *ngIf="mdsSupportTiers.errors.required" class="form-text text-danger">
                        MDS Support Tier is required
                      </span>
                    </div>
                  </div>
                </div>
              </div>
              <div class="form-row" *ngIf="mdsSupportTiers.value != null && mdsSupportTiers.value.includes(3)">
                <div class="form-group form-group-sm row col-24">
                  <label class="col-form-label col-24 col-lg-8 text-danger">Is this customer purchasing 'Supplemental Ethernet' Services?</label>
                  <div class="col-24 col-lg-6 pl-0 pl-lg-1">
                    <dx-radio-group [items]="yesOrNoList" layout="horizontal"
                                    displayExpr="description" valueExpr="value"
                                    formControlName="isSupplementalEthernetSrvc">
                    </dx-radio-group>
                  </div>
                </div>
              </div>
              <div class="form-row">
                <div class="form-group form-group-sm row col-24">
                  <label class="col-form-label col-24 col-lg-6">Network Design Document in DocShare: </label>
                  <div class="col-24 col-lg-18 pl-0 pl-lg-1">
                    <div class="input-group">
                      <input type="text" class="form-control form-control-sm" formControlName="networkDesignDocUrl" />
                      <button type="button" class="btn btn-sm btn-primary" [disabled]="!editMode"
                              (click)="openDesignDocUrl(mdsSupportNddUrl.value)">
                        GO
                      </button>
                    </div>
                  </div>
                </div>
              </div>
              <div class="form-row">
                <div class="form-group form-group-sm row col-24">
                  <label class="col-form-label col-24 col-lg-6">Additional Comments: </label>
                  <div class="col-24 col-lg-18 pl-0 pl-lg-1">
                    <textarea class="form-control form-control-sm" formControlName="comments" rows="5" maxlength="500"></textarea>
                  </div>
                </div>
              </div>
            </div>
          </mat-expansion-panel>
        </mat-accordion>

        <!-- MDS Wholesale Carrier -->
        <mat-accordion *ngIf="customerTypes.value?.includes(1) && plannedSrvcTiers.value?.includes(4)">
          <mat-expansion-panel [expanded]="true" class="mb-1">
            <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
              <mat-panel-title><h6>Wholesale Carrier</h6></mat-panel-title>
            </mat-expansion-panel-header>
            <div formGroupName="mdsWholesaleCarrier">
              <div class="form-row">
                <div class="form-group form-group-sm row col-24">
                  <label class="col-form-label col-24 col-lg-8 text-danger">Please select Primary WAN Transport and # of Site(s): </label>
                  <div class="col-24 col-lg-16 pl-0 pl-lg-1">
                    <dx-data-grid #gridWholesaleCarrierPrimTrnsprt id="gridWholesaleCarrierPrimTrnsprt"
                                  [dataSource]="mdsWholesaleCarrierPrimTransportList"
                                  [showBorders]="true" [wordWrapEnabled]="true" [disabled]="!editMode"
                                  [rowAlternationEnabled]="true" [columnAutoWidth]="true">
                      <dxo-sorting mode="multiple"></dxo-sorting>
                      <dxo-editing mode="cell" [allowAdding]="true"
                                   [allowUpdating]="true" [allowDeleting]="true"></dxo-editing>
                      <dxi-column dataField="cptPrimScndyTprtId" caption="Primary Transport Type" dataType="string">
                        <dxo-lookup [dataSource]="primTransportList" valueExpr="value"
                                    displayExpr="description" [minWidth]="150">
                        </dxo-lookup>
                        <dxi-validation-rule type="required"></dxi-validation-rule>
                      </dxi-column>
                      <dxi-column dataField="qty" caption="Number of Sites" dataType="number" alignment="left">
                        <dxi-validation-rule type="required"></dxi-validation-rule>
                      </dxi-column>
                    </dx-data-grid>
                  </div>
                </div>
              </div>
              <div class="form-row">
                <div class="form-group form-group-sm row col-24">
                  <label class="col-form-label col-24 col-lg-8">Please select Secondary (Backup) Transport Type(s): </label>
                  <div class="col-24 col-lg-16 pl-0 pl-lg-1">
                    <dx-tag-box [dataSource]="primTransportList"
                                displayExpr="description"
                                valueExpr="value"
                                formControlName="secTrnsprtTypes"
                                [showSelectionControls]="true">
                    </dx-tag-box>
                  </div>
                </div>
              </div>
              <div class="form-row">
                <div class="form-group form-group-sm row col-24">
                  <label class="col-form-label col-24 col-lg-6">Network Design Document in DocShare: </label>
                  <div class="col-24 col-lg-18 pl-0 pl-lg-1">
                    <div class="input-group">
                      <input type="text" class="form-control form-control-sm" formControlName="networkDesignDocUrl" />
                      <button type="button" class="btn btn-sm btn-primary" [disabled]="!editMode"
                              (click)="openDesignDocUrl(mdsWholesaleCarrierNddUrl.value)">
                        GO
                      </button>
                    </div>
                  </div>
                </div>
              </div>
              <div class="form-row">
                <div class="form-group form-group-sm row col-24">
                  <label class="col-form-label col-24 col-lg-6">Additional Comments: </label>
                  <div class="col-24 col-lg-18 pl-0 pl-lg-1">
                    <textarea class="form-control form-control-sm" formControlName="comments" rows="5" maxlength="500"></textarea>
                  </div>
                </div>
              </div>
            </div>
          </mat-expansion-panel>
        </mat-accordion>

        <!-- MDS Wholesale VAR -->
        <mat-accordion *ngIf="customerTypes.value?.includes(1) && plannedSrvcTiers.value?.includes(5)">
          <mat-expansion-panel [expanded]="true" class="mb-1">
            <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
              <mat-panel-title><h6>Wholesale VAR</h6></mat-panel-title>
            </mat-expansion-panel-header>
            <div formGroupName="mdsWholesaleVar">
              <div class="form-row">
                <div class="form-group form-group-sm row col-24">
                  <label class="col-form-label col-24 col-lg-8 text-danger">Please select Primary WAN Transport and # of Site(s): </label>
                  <div class="col-24 col-lg-16 pl-0 pl-lg-1">
                    <dx-data-grid #gridWholesaleVarPrimTrnsprt id="gridWholesaleVarPrimTrnsprt"
                                  [dataSource]="mdsWholesaleVarPrimTransportList" [disabled]="!editMode"
                                  [showBorders]="true" [wordWrapEnabled]="true"
                                  [rowAlternationEnabled]="true" [columnAutoWidth]="true">
                      <dxo-sorting mode="multiple"></dxo-sorting>
                      <dxo-editing mode="cell" [allowAdding]="true"
                                   [allowUpdating]="true" [allowDeleting]="true"></dxo-editing>
                      <dxi-column dataField="cptPrimScndyTprtId" caption="Primary Transport Type" dataType="string">
                        <dxo-lookup [dataSource]="primTransportList" valueExpr="value"
                                    displayExpr="description" [minWidth]="150">
                        </dxo-lookup>
                        <dxi-validation-rule type="required"></dxi-validation-rule>
                      </dxi-column>
                      <dxi-column dataField="qty" caption="Number of Sites" dataType="number" alignment="left">
                        <dxi-validation-rule type="required"></dxi-validation-rule>
                      </dxi-column>
                    </dx-data-grid>
                  </div>
                </div>
              </div>
              <div class="form-row">
                <div class="form-group form-group-sm row col-24">
                  <label class="col-form-label col-24 col-lg-8">Please select Secondary (Backup) Transport Type(s): </label>
                  <div class="col-24 col-lg-16 pl-0 pl-lg-1">
                    <dx-tag-box [dataSource]="primTransportList"
                                displayExpr="description"
                                valueExpr="value"
                                formControlName="secTrnsprtTypes"
                                [showSelectionControls]="true">
                    </dx-tag-box>
                  </div>
                </div>
              </div>
              <div class="form-row">
                <div class="form-group form-group-sm row col-24">
                  <label class="col-form-label col-24 col-lg-6">Network Design Document in DocShare: </label>
                  <div class="col-24 col-lg-18 pl-0 pl-lg-1">
                    <div class="input-group">
                      <input type="text" class="form-control form-control-sm" formControlName="networkDesignDocUrl" />
                      <button type="button" class="btn btn-sm btn-primary" [disabled]="!editMode"
                              (click)="openDesignDocUrl(mdsWholesaleVarNddUrl.value)">
                        GO
                      </button>
                    </div>
                  </div>
                </div>
              </div>
              <div class="form-row">
                <div class="form-group form-group-sm row col-24">
                  <label class="col-form-label col-24 col-lg-6">Additional Comments: </label>
                  <div class="col-24 col-lg-18 pl-0 pl-lg-1">
                    <textarea class="form-control form-control-sm" formControlName="comments" rows="5" maxlength="500"></textarea>
                  </div>
                </div>
              </div>
            </div>
          </mat-expansion-panel>
        </mat-accordion>

        <!-- Managed Security Service -->
        <mat-accordion *ngIf="customerTypes.value?.includes(2)">
          <mat-expansion-panel [expanded]="true" class="mb-1">
            <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
              <mat-panel-title><h6>Managed Security Service</h6></mat-panel-title>
            </mat-expansion-panel-header>
            <div formGroupName="mss">
              <div class="form-row">
                <div class="form-group form-group-sm row col-24">
                  <label class="col-form-label col-24 col-lg-8 text-danger">Please select Planned Service Type(s) for this customer: </label>
                  <div class="col-24 col-lg-16 pl-0 pl-lg-1">
                    <dx-tag-box [dataSource]="plannedSrvcTypesList"
                                displayExpr="cptPlnSrvcType"
                                valueExpr="cptPlnSrvcTypeId"
                                formControlName="plannedSrvcTypes"
                                [showSelectionControls]="true">
                    </dx-tag-box>
                    <div *ngIf="plannedSrvcTypes.invalid && (plannedSrvcTypes.dirty || plannedSrvcTypes.touched || isSubmitted)">
                      <span *ngIf="plannedSrvcTypes.errors.required" class="form-text text-danger">
                        Planned Service Type is required
                      </span>
                    </div>
                  </div>
                </div>
              </div>
              <div class="form-row" *ngIf="plannedSrvcTypes.value != null && plannedSrvcTypes.value.includes(3)">
                <div class="form-group form-group-sm row col-24">
                  <label class="col-form-label col-24 col-lg-8 text-danger">Managed Authentication Product: </label>
                  <div class="col-24 col-lg-16 pl-0 pl-lg-1">
                    <dx-tag-box [dataSource]="mngdAuthenticationProdList"
                                displayExpr="cptMngdAuthPrd"
                                valueExpr="cptMngdAuthPrdId"
                                formControlName="mngdAuthenticationProd"
                                [showSelectionControls]="true">
                    </dx-tag-box>
                    <div *ngIf="mngdAuthenticationProd.invalid && (mngdAuthenticationProd.dirty || mngdAuthenticationProd.touched || isSubmitted)">
                      <span *ngIf="mngdAuthenticationProd.errors.required" class="form-text text-danger">
                        Managed Authentication Product is required
                      </span>
                    </div>
                  </div>
                </div>
              </div>
              <div class="form-row">
                <div class="form-group form-group-sm row col-24">
                  <label class="col-form-label col-24 col-lg-4">Additional Comments: </label>
                  <div class="col-24 col-lg-20 pl-0 pl-lg-1">
                    <textarea class="form-control form-control-sm" formControlName="comments" rows="5" maxlength="500"></textarea>
                  </div>
                </div>
              </div>
            </div>
          </mat-expansion-panel>
        </mat-accordion>

        <!-- Managed Voice -->
        <mat-accordion *ngIf="customerTypes.value?.includes(3)">
          <mat-expansion-panel [expanded]="true" class="mb-1">
            <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
              <mat-panel-title><h6>Managed Voice</h6></mat-panel-title>
            </mat-expansion-panel-header>
            <div formGroupName="mvs">
              <div class="form-row">
                <div class="form-group form-group-sm row col-24">
                  <label class="col-form-label col-24 col-lg-11 text-danger">Is the customer requesting co-management of the Unified Communications devices?</label>
                  <div class="col-24 col-lg-3 pl-0 pl-lg-1">
                    <dx-radio-group [items]="yesOrNoList" layout="horizontal"
                                    displayExpr="description" valueExpr="value"
                                    formControlName="isUCDevices">
                    </dx-radio-group>
                  </div>
                  <label class="col-24 col-lg-10">If Yes: Please upload the MIPT co-management agreement before submitting this request.</label>
                </div>
              </div>
              <div class="form-row">
                <div class="form-group form-group-sm row col-24">
                  <label class="col-form-label col-24 col-lg-8 text-danger">Please select MVS Product type(s) for this customer: </label>
                  <div class="col-24 col-lg-16 pl-0 pl-lg-1">
                    <dx-tag-box [dataSource]="mvsProdTypesList"
                                displayExpr="cptMvsProdType"
                                valueExpr="cptMvsProdTypeId"
                                formControlName="mvsProdTypes"
                                [showSelectionControls]="true">
                    </dx-tag-box>
                    <div *ngIf="mvsProdTypes.invalid && (mvsProdTypes.dirty || mvsProdTypes.touched || isSubmitted)">
                      <span *ngIf="mvsProdTypes.errors.required" class="form-text text-danger">
                        MVS Product type is required
                      </span>
                    </div>
                  </div>
                </div>
              </div>
              <app-doc-entity-template [docList]="docList" [option]="option.documentEntity"
                                       [disabled]="!editMode"></app-doc-entity-template>
            </div>
          </mat-expansion-panel>
        </mat-accordion>

        <!-- Unmanaged E2E -->
        <mat-accordion *ngIf="customerTypes.value?.includes(4)">
          <mat-expansion-panel [expanded]="true" class="mb-1">
            <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
              <mat-panel-title><h6>Unmanaged E2E</h6></mat-panel-title>
            </mat-expansion-panel-header>
            <div formGroupName="e2e">
              <div class="form-row">
                <div class="form-group form-group-sm row col-24">
                  <label class="col-form-label col-24 col-lg-14 text-danger">Please be sure to complete the E2E tab on the Network Design Doc (NDD) and post to Folder 4 in DocShare: </label>
                  <div class="col-24 col-lg-8 pl-0 pl-lg-1">
                    <dx-radio-group [items]="yesOrNoList" layout="horizontal"
                                    displayExpr="description" valueExpr="value"
                                    formControlName="isNddToDocshare">
                    </dx-radio-group>
                  </div>
                </div>
              </div>
              <div class="form-row">
                <div class="form-group form-group-sm row col-24">
                  <label class="col-form-label col-24 col-lg-6">Link to Network Design Document in DocShare: </label>
                  <div class="col-24 col-lg-18 pl-0 pl-lg-1">
                    <div class="input-group">
                      <input type="text" class="form-control form-control-sm" formControlName="networkDesignDocUrl" />
                      <button type="button" class="btn btn-sm btn-primary" [disabled]="!editMode"
                              (click)="openDesignDocUrl(e2eNddUrl.value)">
                        GO
                      </button>
                    </div>
                  </div>
                </div>
              </div>
              <div class="form-row">
                <div class="form-group form-group-sm row col-24">
                  <label class="col-form-label col-24 col-lg-4">Additional Comments: </label>
                  <div class="col-24 col-lg-20 pl-0 pl-lg-1">
                    <textarea class="form-control form-control-sm" formControlName="comments" rows="5" maxlength="500"></textarea>
                  </div>
                </div>
              </div>
            </div>
          </mat-expansion-panel>
        </mat-accordion>

        <!-- SPS -->
        <mat-accordion *ngIf="customerTypes.value?.includes(5)">
          <mat-expansion-panel [expanded]="true" class="mb-1">
            <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
              <mat-panel-title><h6>Professional Services</h6></mat-panel-title>
            </mat-expansion-panel-header>
            <div formGroupName="sps">
              <div class="form-row">
                <div class="form-group form-group-sm row col-24">
                  <label class="col-form-label col-24 col-lg-10 text-danger">Please ensure the Professional Services SOW has been posted to Folder 4 in DocShare: </label>
                  <div class="col-24 col-lg-6 pl-0 pl-lg-1">
                    <dx-radio-group [items]="yesOrNoList" layout="horizontal"
                                    displayExpr="description" valueExpr="value"
                                    formControlName="isSpsSowToDocshare">
                    </dx-radio-group>
                  </div>
                </div>
              </div>
              <div class="form-row">
                <div class="form-group form-group-sm row col-24">
                  <label class="col-form-label col-24 col-lg-6">Link to Network Design Document in DocShare: </label>
                  <div class="col-24 col-lg-18 pl-0 pl-lg-1">
                    <div class="input-group">
                      <input type="text" class="form-control form-control-sm" formControlName="networkDesignDocUrl" />
                      <button type="button" class="btn btn-sm btn-primary" [disabled]="!editMode"
                              (click)="openDesignDocUrl(spsNddUrl.value)">
                        GO
                      </button>
                    </div>
                  </div>
                </div>
              </div>
              <div class="form-row">
                <div class="form-group form-group-sm row col-24 text-danger">
                  <label>
                    Note: As of 15 Aug 2011, MNS will support MNS MPLS only design and provisioning reports in DesignCentral.
                    If you are using DesignCentral for any other MNS services,
                    please generate the required MNS design and provisioning reports in DesignExpert,
                    then post them to the appropriate design repository (DocShare),
                    and provide a valid link in the above field.
                  </label>
                </div>
              </div>
              <div class="form-row">
                <div class="form-group form-group-sm row col-24">
                  <label class="col-form-label col-24 col-lg-4">Additional Comments: </label>
                  <div class="col-24 col-lg-20 pl-0 pl-lg-1">
                    <textarea class="form-control form-control-sm" formControlName="comments" rows="5" maxlength="500"></textarea>
                  </div>
                </div>
              </div>
            </div>
          </mat-expansion-panel>
        </mat-accordion>

        <!-- Provisioning -->
        <mat-accordion *ngIf="id > 0">
          <mat-expansion-panel [expanded]="true" class="mb-1">
            <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
              <mat-panel-title><h6>Provisioning Status</h6></mat-panel-title>
            </mat-expansion-panel-header>
            <div formGroupName="provisioning">
              <div class="form-row">
                <div class="form-group form-group-sm row col-24 text-danger">
                  <label *ngIf="hasProvisioning && !allowProvision">
                    Sorry, you do not have access to update <span class="font-weight-bold">THIS SECTION</span>. Kindly contact your supervisor or application administrator for details.
                  </label>
                  <label *ngIf="!hasProvisioning">
                    This section is not applicable for this type of request.
                  </label>
                </div>
              </div>
              <div class="form-row">
                <div class="form-group form-group-sm row col-24 col-lg-12">
                  <label class="col-form-label col-24 col-lg-8 text-danger">Customer Short Name: </label>
                  <div class="col-24 col-lg-16 pl-0 pl-lg-1">
                    <input #shortName type="text" class="form-control form-control-sm" formControlName="shortName"
                           (change)="shortnameChange(shortName.value)" />
                  </div>
                </div>
                <div class="form-group form-group-sm row col-24 col-lg-12"
                     *ngIf="isSdwanMerakiOnlyCustomer.value == null || !isSdwanMerakiOnlyCustomer.value">
                  <label class="col-form-label col-24 col-lg-8 text-danger">QIP Subnet Name: </label>
                  <div class="col-24 col-lg-16 pl-0 pl-lg-1">
                    <input type="text" class="form-control form-control-sm" formControlName="qipSubnet" />
                  </div>
                </div>
              </div>
              <div class="form-row">
                <div class="form-group form-group-sm row col-24 col-lg-12"
                     *ngIf="primeSite.value?.length > 0">
                  <label class="col-form-label col-24 col-lg-8 text-danger">Prime Site: </label>
                  <div class="col-24 col-lg-16 pl-0 pl-lg-1">
                    <dx-tag-box [dataSource]="primeSitesList"
                                displayExpr="cptPrimSite"
                                valueExpr="cptPrimSiteId"
                                formControlName="primeSite"
                                [showSelectionControls]="true">
                    </dx-tag-box>
                  </div>
                </div>
                <div class="form-group form-group-sm row col-24 col-lg-12" *ngIf="isTacacs.value">
                  <label class="col-form-label col-24 col-lg-8">Pre-Shared Key: </label>
                  <div class="col-24 col-lg-16 pl-0 pl-lg-1">
                    <input type="text" class="form-control form-control-sm" formControlName="preSharedKey" />
                  </div>
                </div>
              </div>
              <div class="form-row" *ngIf="showIpAddress">
                <div class="form-group form-group-sm row col-24">
                  <label class="col-form-label col-4">IP Subnet: </label>
                  <div class="col-5 pl-0 pl-lg-1">
                    <input type="text" class="form-control form-control-sm" formControlName="ipSubnet" />
                    <div *ngIf="ipSubnet.invalid && (ipSubnet.dirty || ipSubnet.touched || isSubmitted)">
                      <span *ngIf="ipSubnet.errors.invalidIp" class="form-text text-danger">
                        IP Subnet is invalid
                      </span>
                    </div>
                  </div>
                  <label class="col-form-label col-3">Start IP: </label>
                  <div class="col-5 pl-0 pl-lg-1">
                    <input type="text" class="form-control form-control-sm" formControlName="startIp" />
                    <div *ngIf="startIp.invalid && (startIp.dirty || startIp.touched || isSubmitted)">
                      <span *ngIf="startIp.errors.invalidIp" class="form-text text-danger">
                        Start IP is invalid
                      </span>
                    </div>
                  </div>
                  <label class="col-form-label col-2">End IP: </label>
                  <div class="col-5 pl-0 pl-lg-1">
                    <input type="text" class="form-control form-control-sm" formControlName="endIp" />
                    <div *ngIf="endIp.invalid && (endIp.dirty || endIp.touched || isSubmitted)">
                      <span *ngIf="endIp.errors.invalidIp" class="form-text text-danger">
                        End IP is invalid
                      </span>
                    </div>
                  </div>
                </div>
              </div>
              <div class="form-row" *ngIf="cptData?.cptStusId > 305 && provisioningList?.length > 0">
                <dx-data-grid #gridProvisioning id="gridProvisioning"
                              [dataSource]="provisioningList" keyExpr="cptPrvsnId"
                              [showBorders]="true" [wordWrapEnabled]="true"
                              [rowAlternationEnabled]="true" [columnAutoWidth]="true"
                              [disabled]="!editMode || provisioning.disabled">
                  <dxo-sorting mode="multiple"></dxo-sorting>
                  <dxi-column dataField="cptPrvsnType" caption="System" dataType="string"></dxi-column>
                  <dxi-column dataField="prvsnStus" caption="Needed" dataType="string"></dxi-column>
                  <dxi-column dataField="srvrNme" caption="Server Name" dataType="string"></dxi-column>
                  <dxi-column dataField="creatDt" caption="Created Date" dataType="string"
                              cellTemplate="localStartTime"></dxi-column>
                  <dxi-column dataField="modfdDt" caption="Modified Date" dataType="string"
                              cellTemplate="localStartTime"></dxi-column>
                  <dxi-column dataField="recStus" caption="Provisioning Status" dataType="string"></dxi-column>
                  <dxi-column dataField="prvsnNteTxt" caption="Provisioning Note" dataType="string"></dxi-column>
                  <div *dxTemplate="let cell of 'localStartTime'">
                    <span>{{cell.text | date:'MM/dd/yyyy hh:mm a'}}</span>
                  </div>
                </dx-data-grid>
              </div>
            </div>
          </mat-expansion-panel>
        </mat-accordion>

        <!-- Assignment -->
        <mat-accordion *ngIf="cptData?.cptStusId > 306">
          <mat-expansion-panel [expanded]="true" class="mb-1">
            <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
              <mat-panel-title><h6>Resource Assignment</h6></mat-panel-title>
            </mat-expansion-panel-header>
            <div formGroupName="assignment">
              <div class="form-row">
                <div class="form-group form-group-sm row col-24 text-danger">
                  <label *ngIf="hasAssignment && !allowAssignment">
                    Sorry, you do not have access to update <span class="font-weight-bold">THIS SECTION</span>. Kindly contact your supervisor or application administrator for details.
                  </label>
                  <label *ngIf="!hasAssignment">
                    This section is not applicable for this type of request.
                  </label>
                </div>
              </div>
              <div class="form-row">
                <div class="form-group form-group-sm row col-9">
                  <label class="col-form-label col-8">GateKeeper: </label>
                  <div class="col-16 pl-0 pl-lg-1">
                    <dx-select-box [items]="gkList" formControlName="gatekeeper"
                                   displayExpr="fullName" valueExpr="userId" [disabled]="disableGk"
                                   [searchEnabled]="true" [searchExpr]="['fullName']"
                                   searchMode="startswith"></dx-select-box>
                  </div>
                </div>
                <div class="form-group form-group-sm row col-9">
                  <label class="col-form-label col-8">NTE: </label>
                  <div class="col-16 pl-0 pl-lg-1">
                    <dx-select-box [items]="nteList" formControlName="nte" [disabled]="disableNte"
                                   displayExpr="displayField" valueExpr="userId"
                                   [searchEnabled]="true" [searchExpr]="['displayField']"
                                   searchMode="startswith"></dx-select-box>
                  </div>
                </div>
                <div class="form-group form-group-sm row col-6">
                  <div class="input-group">
                    <dx-check-box formControlName="reviewedByPm" text="Reviewed by PM"
                                  (onValueChanged)="onReviewedPmChanged($event)"></dx-check-box>
                    <label *ngIf="cptData.reviewedByPMDate != '' || cptData.reviewedByPMDate != null">
                      {{ cptData.reviewedByPMDate }}
                    </label>
                  </div>
                </div>
              </div>
              <div class="form-row">
                <div class="form-group form-group-sm row col-9">
                  <label class="col-form-label col-8">Manager: </label>
                  <div class="col-16 pl-0 pl-lg-1">
                    <dx-select-box [items]="managerList" formControlName="manager"
                                   displayExpr="fullName" valueExpr="userId" [disabled]="disableManager"
                                   [searchEnabled]="true" [searchExpr]="['fullName']"
                                   searchMode="startswith" (onValueChanged)="onManagerChanged($event)">
                    </dx-select-box>
                  </div>
                </div>
                <div class="form-group form-group-sm row col-9">
                  <label class="col-form-label col-8">PM: </label>
                  <div class="col-16 pl-0 pl-lg-1">
                    <dx-select-box [items]="pmList" formControlName="pm" [disabled]="disablePm"
                                   displayExpr="fullName" valueExpr="userId"
                                   [searchEnabled]="true" [searchExpr]="['fullName']"
                                   searchMode="startswith"></dx-select-box>
                  </div>
                </div>
                <div class="form-group form-group-sm row col-6">
                  <div class="input-group">
                    <dx-check-box formControlName="returnedToSde" text="Returned to SDE"></dx-check-box>
                    <label *ngIf="cptData.returnedToSDEDate != '' || cptData.returnedToSDEDate != null">
                      {{ cptData.returnedToSDEDate }}
                    </label>
                  </div>
                </div>
              </div>
              <div class="form-row">
                <div class="form-group form-group-sm row col-9">
                  <label class="col-form-label col-8"
                         *ngIf="customerTypes.value?.includes(2) || customerTypes.value?.includes(5)">MSS: </label>
                  <div class="col-16 pl-0 pl-lg-1"
                       *ngIf="customerTypes.value?.includes(2) || customerTypes.value?.includes(5)">
                    <dx-select-box [items]="mssList" formControlName="mss"
                                   displayExpr="fullName" valueExpr="userId"
                                   [searchEnabled]="true" [searchExpr]="['fullName']"
                                   searchMode="startswith"></dx-select-box>
                  </div>
                </div>
                <div class="form-group form-group-sm row col-9">
                  <label class="col-form-label col-8">CRM: </label>
                  <div class="col-16 pl-0 pl-lg-1">
                    <dx-select-box [items]="crmList" formControlName="crm" [disabled]="disableCrm"
                                   displayExpr="fullName" valueExpr="userId"
                                   [searchEnabled]="true" [searchExpr]="['fullName']"
                                   searchMode="startswith"></dx-select-box>
                  </div>
                </div>
              </div>
              <div class="form-row" *ngIf="showReviewProvisionError">
                <div class="form-group form-group-sm row col-24">
                  <label class="text-danger">
                    Some of the provisioning types are not in SUCCESS status
                    (please check the provisioning status table above), Reviewed by PM
                    functionality will work only when all the needed provisioning types are in SUCCESS status.
                  </label>
                </div>
              </div>
            </div>
          </mat-expansion-panel>
        </mat-accordion>

        <!-- Notes -->
        <mat-accordion>
          <mat-expansion-panel [expanded]="true" class="mb-1">
            <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
              <mat-panel-title><h6>Notes</h6></mat-panel-title>
            </mat-expansion-panel-header>
            <div class="form-row" *ngIf="id > 0">
              <div class="form-group form-group-sm row col-24">
                <label class="col-form-label col-24 col-lg-4">Cancel CPT Request: </label>
                <div class="col-24 col-lg-20 pl-0 pl-lg-1">
                  <dx-check-box formControlName="cancelCpt"></dx-check-box>
                </div>
              </div>
            </div>
            <div class="form-row">
              <div class="form-group form-group-sm row col-24">
                <label class="col-form-label col-24 col-lg-4">Notes: </label>
                <div class="col-24 col-lg-20 pl-0 pl-lg-1">
                  <textarea class="form-control form-control-sm" formControlName="notes" rows="5" maxlength="500"></textarea>
                </div>
              </div>
            </div>
          </mat-expansion-panel>
        </mat-accordion>

        <!-- History -->
        <mat-accordion *ngIf="id > 0">
          <mat-expansion-panel collapsedHeight="inherit" expandedHeight="inherit" [expanded]="true" class="mb-1">
            <mat-expansion-panel-header class="card-header py-2 px-3">
              <mat-panel-title><h6>History</h6></mat-panel-title>
            </mat-expansion-panel-header>
            <dx-data-grid #gridHistory id="gridHistory" [dataSource]="cptData?.cptHist"
                          keyExpr="cptHistId" [showBorders]="true" [wordWrapEnabled]="true"
                          [rowAlternationEnabled]="true" [columnAutoWidth]="true">
              <dxo-sorting mode="multiple"></dxo-sorting>
              <dxi-column dataField="actionName" caption="Note Type" dataType="string"></dxi-column>
              <dxi-column dataField="createdBy" caption="User Name" dataType="string"></dxi-column>
              <dxi-column dataField="creatDt" caption="Date Created" dataType="string"
                          cellTemplate="localStartTime"></dxi-column>
              <dxi-column dataField="cmntTxt" caption="Notes" dataType="string"></dxi-column>
              <div *dxTemplate="let cell of 'localStartTime'">
                <span>{{cell.text | date:'MM/dd/yyyy hh:mm a'}}</span>
              </div>
            </dx-data-grid>
          </mat-expansion-panel>
        </mat-accordion>

        <div class="form-row text-center mt-1">
          <div class="form-group form-group-sm row col-24 text-danger">
            <h6 class="col-24 text-center" *ngIf="!isLocked && editMode && allowEdit && id > 0">This CPT Request will be locked from other users until you click the Save or Cancel button.</h6>
            <h6 class="col-24 text-center" *ngIf="isLocked">This CPT is currently locked by {{ lockedByUser }}</h6>
            <h6 class="col-24 text-center" *ngIf="!allowEdit">This CPT request has been {{ cptData?.cptStatus }}. Updating this record is not allowed.</h6>
            <h6 class="col-24 text-center" *ngIf="viewOnly">Sorry, you do not have access to update this CPT Request. Kindly contact your supervisor or application administrator for details.</h6>
          </div>
          <div class="form-group form-group-sm col-12 col-md-6 col-lg-4 offset-md-6 offset-lg-8"
               *ngIf="!isLocked && allowEdit && !viewOnly">
            <div *ngIf="editMode; then saveTemplate; else editTemplate;"></div>
            <ng-template #editTemplate>
              <button type="button" class="btn btn-sm btn-primary btn-block" (click)="edit()">
                Edit
              </button>
            </ng-template>
            <ng-template #saveTemplate>
              <button type="button" class="btn btn-sm btn-primary btn-block" (click)="save()">
                Save
              </button>
            </ng-template>
          </div>
          <div class="form-group form-group-sm col-12 col-md-6 col-lg-4"
               [ngClass]="{ 'offset-lg-10' : (isLocked || !allowEdit || viewOnly) }">
            <button type="button" class="btn btn-sm btn-secondary btn-block" (click)="cancel()">
              Cancel
            </button>
          </div>
        </div>
      </form>
    </div>
  </div>
</div>
<app-validation-summary [errors]="errors" [option]="option.validationSummaryOptions"></app-validation-summary>
